Bug 52298 - Can't enter website with client certificate on an iPad
Summary: Can't enter website with client certificate on an iPad
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_ssl (show other bugs)
Version: 2.2.21
Hardware: Other other
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2011-12-07 09:01 UTC by Stefan Blanke
Modified: 2018-11-07 21:09 UTC (History)
1 user (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Stefan Blanke 2011-12-07 09:01:40 UTC
Configured an XAMPP installation (1.7.7) to enter a website with client certificates. Works fine in Firefox, IE and Chrome. 

But when entering the website with an iPad (tested on an iPad 2) there comes no prompt (as expected) to select a client certificate. It just returns a 403 error.

Using an older XAMPP installation (1.7.4) with Apache 2.2.17 everything works fine.


Snippet of my ssl config:

httpd-ssl.conf:
...
SSLVerifyClient optional 
SSLVerifyDepth 10
Include conf/extra/httpd-ssl-papp.conf
...

httpd-ssl-papp.conf:
<Location /test>
      SSLRequire %{SSL_CLIENT_S_DN_CN} in { "CERT NAME" }
</Location>
Comment 1 Erwann Abalea 2011-12-07 11:23:27 UTC
It's not a bug in Apache, but a problem in Mobile Safari behavior.
Change the "SSLVerifyClient optional" into "SSLVerifyClient verify", and you'll be prompted.
Mobile Safari tries to connect to a site without a client certificate, and if it works, no renegotiation will be accepted.
Comment 2 Erwann Abalea 2011-12-07 11:24:41 UTC
Sorry, use "SSLVerifyClient require" instead.
Comment 3 Stefan Blanke 2011-12-08 09:07:49 UTC
After setting it to require instead of optional I get the following error message:
"This website requires a certificate to validate your identity."
or similar to this, I just translated it.

But the p12-cert is installed correctly.
Comment 4 Eric Covener 2011-12-08 11:30:28 UTC
maybe it's not signed by a CA trusted by the server.
Comment 5 Stefan Blanke 2011-12-08 12:34:44 UTC
The server trusts the CA. Otherwise it couldn't work in other browsers. We used the same files like on the older version.

On client side: client.p12, root CA, client CA
On server side: server.crt, server.key, server-chain.crt

client CA and server CA are built from the root CA.
Comment 6 Eric Covener 2011-12-08 21:04:23 UTC
Can you show how the handshakes differ between the two versions?
Comment 7 William A. Rowe Jr. 2018-11-07 21:09:31 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.